--- old/usr/src/cmd/svc/startd/transition.c	2016-07-31 04:30:35.964200161 +0100
+++ new/usr/src/cmd/svc/startd/transition.c	2016-07-31 04:30:35.969211954 +0100
@@ -21,6 +21,8 @@
 /*
  * Copyright 2009 Sun Microsystems, Inc.  All rights reserved.
  * Use is subject to license terms.
+ *
+ * Copyright 2016 RackTop Systems.
  */
 
 
@@ -137,6 +139,13 @@
 		    "%s.\n", v->gv_name);
 
 		graph_transition_propagate(v, PROPAGATE_STOP, rerr);
+
+		/*
+		 * The maintenance transition may satisfy optional_all/restart
+		 * dependencies and should be propagated to determine
+		 * whether new dependents are satisfiable.
+		 */
+		graph_transition_propagate(v, PROPAGATE_SAT, rerr);
 	} else {
 		log_framework(LOG_DEBUG, "Propagating maintenance of %s.\n",
 		    v->gv_name);
@@ -267,6 +276,12 @@
 
 		graph_transition_propagate(v, PROPAGATE_STOP, rerr);
 
+		/*
+		 * The disable transition may satisfy optional_all/restart
+		 * dependencies and should be propagated to determine
+		 * whether new dependents are satisfiable.
+		 */
+		graph_transition_propagate(v, PROPAGATE_SAT, rerr);
 	} else {
 		log_framework(LOG_DEBUG, "Propagating disable of %s.\n",
 		    v->gv_name);
@@ -326,9 +341,10 @@
 		 * because the instance was transitioning from offline to
 		 * online and the reverse disable algorithm doesn't offline
 		 * those instances because it was already appearing offline.
-		 * So do it now.
+		 * Try to do it now.
 		 */
-		offline_vertex(v);
+		if (insubtree_dependents_down(v))
+			offline_vertex(v);
 	}
 
 	if (gt_running(old_state) == 0) {
